oracle.kv.table

## Interface Row

- All Superinterfaces:
    Comparable<FieldValue>, FieldValue, RecordValue
  All Known Subinterfaces:
    PrimaryKey, ReturnRow

      public interface Row
      extends RecordValue

  Row is a specialization of RecordValue to represent a single record, or row, in a table. It is a central object used in most table operations defined in `TableAPI`.

  Row objects are constructed explicitly using `createRow` or implicitly when returned from table access operations.

  Since:
    3.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Row` | `clone()` Returns a deep copy of this object.
    `PrimaryKey` | `createPrimaryKey()` Creates a PrimaryKey from this Row.
    `boolean` | `equals(Object other)` Equality comparison for Row instances is based on equality of the individual field values and ignores the included `Version`, if present.
    `Table` | `getTable()` Return the Table associated with this row.
    `int` | `getTableVersion()` Returns the version of the table used to create this row if it has been deserialized from a get operation.
    `Version` | `getVersion()` Returns the Version for the row.

    - ### Methods inherited from interface oracle.kv.table.RecordValue

      `contains, copyFrom, get, getDefinition, getFields, isEmpty, put, put, put, put, put, put, put, put, putArray, putEnum, putFixed, putMap, putNull, putRecord, remove, size`

    - ### Methods inherited from interface oracle.kv.table.FieldValue

      `asArray, asBinary, asBoolean, asDouble, asEnum, asFixedBinary, asFloat, asIndexKey, asInteger, asLong, asMap, asPrimaryKey, asRecord, asRow, asString, getType, isArray, isBinary, isBoolean, isDouble, isEnum, isFixedBinary, isFloat, isIndexKey, isInteger, isLong, isMap, isNull, isPrimaryKey, isRecord, isRow, isString, toJsonString`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Method Detail

    - #### getTable

          Table getTable()

      Return the Table associated with this row.
      Returns:
        the Table

    - #### getVersion

          Version getVersion()

      Returns the Version for the row. The description of `Version` in its class description refers to its use in the `KVStore` interface. In `TableAPI` it it used as a return value for the various put methods as well as `TableAPI.putIfVersion(oracle.kv.table.Row, oracle.kv.Version, oracle.kv.table.ReturnRow, oracle.kv.table.WriteOptions)` and `TableAPI.deleteIfVersion(oracle.kv.table.PrimaryKey, oracle.kv.Version, oracle.kv.table.ReturnRow, oracle.kv.table.WriteOptions)` to perform conditional updates to allow an application to ensure that an update is occurring on the desired version of a row.
      Returns:
        the Version object if it has been initialized, null otherwise. The Version will only be set if the row was retrieved from the store.

    - #### createPrimaryKey

          PrimaryKey createPrimaryKey()

      Creates a PrimaryKey from this Row. The non-key fields are removed.
      Returns:
        the PrimaryKey

    - #### getTableVersion

          int getTableVersion()

      Returns the version of the table used to create this row if it has been deserialized from a get operation. If the row has been created and never been serialized the version returned is 0. New Table versions are created when a table is schema evolved. Tables start out with version 1 and it increments with each change. This method can be used by applications to help handle version changes.

    - #### equals

          boolean equals(Object other)

      Equality comparison for Row instances is based on equality of the individual field values and ignores the included `Version`, if present.
      Overrides:
        `equals` in class `Object`
      Returns:
        true if the objects are equal

    - #### clone

          Row clone()

      Returns a deep copy of this object.
      Specified by:
        `clone` in interface `FieldValue`
      Specified by:
        `clone` in interface `RecordValue`
      Returns:
        a deep copy of this object

Copyright (c) 2011, 2014 Oracle and/or its affiliates. All rights reserved.